Unit AM07R_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc;

procedure AM07R(var A :Array of Real; N :Integer; M :Integer;
                var B :Array of Real); 
implementation

procedure AM07R(var A :Array of Real; N :Integer; M :Integer;
                var B :Array of Real);
var
I,J,K :Integer;
R,R1,R2,T,C,S :Real;
label
_1,_2;
begin
for K:=1 to M do
 begin
  J := K+1;
  if ( J > N ) 
   then goto _2;
  for I:=J to N do
   begin
    T := A[(I-1)+(K-1)*N];
    R := T*T;
    R1 := 1.0/(1.0+R);
    C := (1.0-R)*R1;
    S := (T+T)*R1;
    R1 := B[K-1];
    R2 := B[I-1];
    B[K-1] := C*R1-S*R2;
    B[I-1] := S*R1+C*R2;
_1:
   end;
_2:
 end;
end;

end.
